/*
 * Copyright (C) 2009 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.example.android.businesscard;
import sparta.checkers.quals.*;
import static sparta.checkers.quals.FlowPermission.*;

/**
 * A model object containing contact data.
 */
public class ContactInfo {

    private @Source(DATABASE) String mDisplayName;
    private @Source(DATABASE) String mPhoneNumber;

    public void setDisplayName(@Source(DATABASE) String displayName) {
        this.mDisplayName = displayName;
    }

    public @Source(DATABASE) String getDisplayName() {
        return mDisplayName;
    }

    public void setPhoneNumber(@Source(DATABASE) String phoneNumber) {
        this.mPhoneNumber = phoneNumber;
    }

    public @Source(DATABASE) String getPhoneNumber() {
        return mPhoneNumber;
    }
}
