// "derived from OATH HOTP algorithm"

package org.dynalogin.android;
import sparta.checkers.quals.*;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;
public class HOTP
{
    public @Source({FlowPermission.LITERAL, FlowPermission.DATABASE}) String gen(@Source(FlowPermission.DATABASE) String seed,  @Source({FlowPermission.DATABASE, FlowPermission.LITERAL}) int count, @Source(FlowPermission.LITERAL) int digits)
    {
        try
        {
            return generateOTP(seed.getBytes(), count, digits);
        } catch (InvalidKeyException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (NoSuchAlgorithmException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        // The returning of a blank string could indicate something about the sensitive parameters, therefore the return value of "" is in fact @PolySource
        String blankRet = "";
        return blankRet;
    }

    public static @Source({FlowPermission.DATABASE, FlowPermission.LITERAL}) byte [] hmac_sha1(byte @Source({FlowPermission.DATABASE, FlowPermission.LITERAL}) [] keyBytes, @Source({FlowPermission.DATABASE, FlowPermission.LITERAL}) byte [] text)
            throws NoSuchAlgorithmException, InvalidKeyException
    {
        // try {
        Mac hmacSha1;
        try
        {
            hmacSha1 = Mac.getInstance("HmacSHA1");
        } catch (NoSuchAlgorithmException nsae)
        {
            hmacSha1 = Mac.getInstance("HMAC-SHA-1");
        }
        @Source({FlowPermission.DATABASE, FlowPermission.LITERAL}) SecretKeySpec macKey = new SecretKeySpec(keyBytes, "RAW");
        hmacSha1.init(macKey);
        return hmacSha1.doFinal(text);
    }

    static private @Source({FlowPermission.LITERAL, FlowPermission.DATABASE}) String generateOTP( byte @Source(FlowPermission.DATABASE) [] secret,  @Source({FlowPermission.DATABASE, FlowPermission.LITERAL}) long movingFactor,
                                      @Source(FlowPermission.LITERAL) int codeDigits) throws NoSuchAlgorithmException,
            InvalidKeyException
    {
        // put movingFactor value into text byte array
        String result = null;

        @Source({FlowPermission.DATABASE, FlowPermission.LITERAL}) byte [] text = new byte[8];
        for (int i = text.length - 1; i >= 0; i--)
        {
            text[i] = (@Source({FlowPermission.DATABASE, FlowPermission.LITERAL}) byte) (movingFactor & 0xff);
            
            movingFactor >>= (long) 8;
        }

        // compute hmac hash
         @Source({FlowPermission.DATABASE, FlowPermission.LITERAL}) byte [] hash = hmac_sha1(secret, text);

        // put selected bytes into result int
        int offset = hash[hash.length - 1] & 0xf;
        int binary = ((hash[offset] & 0x7f) << 24)
                | ((hash[offset + 1] & 0xff) << 16)
                | ((hash[offset + 2] & 0xff) << 8) | (hash[offset + 3] & 0xff);

        int otp = (int) (binary % Math.pow(10, codeDigits));
//        int otp = binary % DIGITS_POWER[codeDigits];
        result = Integer.toString(otp);
        while (result.length() < codeDigits)
        {
            result = "0" + result;
        }
        return result;
    }
}