package org.dynalogin.android;
import sparta.checkers.quals.*;

import android.database.Cursor;

public class HOTPProvider {
	
	HOTP hotp = new HOTP();
    @Source(FlowPermission.LITERAL) ProfileStore profileStore;
	
	private final static int CODE_LENGTH = 6;
	
    private @Source({FlowPermission.SHARED_PREFERENCES, FlowPermission.LITERAL}) int profileId = -1;
    private @Source(FlowPermission.DATABASE) String profileName = null;
    private @Source(FlowPermission.DATABASE) String secret = null;
    private @Source({FlowPermission.DATABASE, FlowPermission.LITERAL}) int seq = -1;
	
    public HOTPProvider(@Source(FlowPermission.LITERAL) ProfileStore _profileStore) {
		profileStore = _profileStore;
	}
	
    public void selectProfile(@Source(FlowPermission.SHARED_PREFERENCES) int _id) {
		profileStore.open();
		//Cursor profilesCursor = profileStore.getAllProfiles();
		//profilesCursor.moveToPosition(_id);

		Cursor profilesCursor = profileStore.getProfile(_id);
		
		int col_index = profilesCursor.getColumnIndexOrThrow(ProfileStore.KEY_PROF_NAME);
		profileName = profilesCursor.getString(col_index);
		
		col_index = profilesCursor.getColumnIndexOrThrow(ProfileStore.KEY_SECRET);
		secret = profilesCursor.getString(col_index);
		
		col_index = profilesCursor.getColumnIndexOrThrow(ProfileStore.KEY_SEQ);
		seq = profilesCursor.getInt(col_index);
		
		profilesCursor.close();
		profileStore.close();
		
		profileId = _id;

	}
	
    public @Source(FlowPermission.DATABASE) String getProfileName() {
		return profileName;
	}
	
    public @Source({FlowPermission.DATABASE, FlowPermission.LITERAL}) String getNextCode() {
		
		if(profileId == -1)
			return null;
        
        String code = hotp.gen(
                secret,
                seq,
                CODE_LENGTH);
        
        seq ++;
        profileStore.open();
        profileStore.updateCount(profileId, seq);
        profileStore.close();
        
        return code;
	}
	
	

}
