/*
 * This file is part of RingyDingyDingy.
 * Copyright (C) 2011-2012 Ayron Jungren
 *
 * RingyDingyDingy is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3 of the License only.
 *
 * RingyDingyDingy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with RingyDingyDingy.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.dririan.RingyDingyDingy;

import static  sparta.checkers.quals.FlowPermission.*;
import sparta.checkers.quals.Sink;
import sparta.checkers.quals.Source;
import android.content.ContentResolver;
import android.content.Context;
import android.database.Cursor;
import android.net.Uri;
import android.provider.ContactsContract.PhoneLookup;

public class ContactSupport {

    public static @Source(READ_CONTACTS) String[] lookupByNumber(Context context,  @Sink({DATABASE, CONDITIONAL}) String phoneNumber) {
        ContentResolver contentResolver = context.getContentResolver();
        Cursor cursor = null;
        @Source(READ_CONTACTS)  String[] contact = new String[1];
        Uri uri = Uri.withAppendedPath(PhoneLookup.CONTENT_FILTER_URI, Uri.encode(phoneNumber));
        cursor = contentResolver.query(uri, new String[]{PhoneLookup.DISPLAY_NAME}, null, null, null);

        int index = cursor.getColumnIndex(PhoneLookup.DISPLAY_NAME);
        if(cursor != null) {
            if(cursor.getCount() > 0) {
                cursor.moveToNext();
                @SuppressWarnings("flow")//The cursor is from the contact database, but the Flow Checker doesn't know it
                String tmp =  ( /*@Source(READ_CONTACTS)*/ String) cursor.getString(index);
                contact[0] = tmp;
            }
            else
                contact[0] = null;
        }
        cursor.close();

        return contact;
    }

}
