package goo.TeaTimer;


import android.database.Cursor;
import android.os.Bundle;
import android.preference.ListPreference;
import android.preference.PreferenceActivity;
import android.provider.MediaStore;
import android.util.Log;

import static sparta.checkers.quals.FlowPermission.*;
import sparta.checkers.quals.*;

public class TimerPrefActivity extends PreferenceActivity 
{
	private static final String TAG = TimerPrefActivity.class.getSimpleName();
	
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        // Load the preferences from an XML resource
        addPreferencesFromResource(R.xml.preferences);
        
        // Load the sounds
        ListPreference tone = (ListPreference)findPreference("NotificationUri");
        	
    	String [] cols = { MediaStore.Audio.Media._ID, MediaStore.Audio.Media.TITLE};
    	
    	// Lets check out the media provider
        Cursor cursor = managedQuery(MediaStore.Audio.Media.INTERNAL_CONTENT_URI, 
        		cols, 
        		MediaStore.Audio.AudioColumns.IS_RINGTONE + "==1",        	
        		null, null);
         int i=0;
   
         @Source(DATABASE) CharSequence[] items = null;
         @Source({LITERAL,DATABASE}) CharSequence[] itemUris = null;
         
        if(cursor != null && cursor.getCount() > 0){
        	
            items = new CharSequence[cursor.getCount()];
            itemUris = new CharSequence[cursor.getCount()];
        
        	int colTitle = cursor.getColumnIndex(MediaStore.Audio.Media.TITLE);;
        	int colId = cursor.getColumnIndex(MediaStore.Audio.Media._ID);;
	        
        	while(!cursor.isLast()){
	        	cursor.moveToNext();
	        	items[i] = cursor.getString(colTitle);
	        	itemUris[i] = MediaStore.Audio.Media.INTERNAL_CONTENT_URI + "/" + cursor.getLong(colId);
	        	i++;
        	}
        
	        cursor.close();   
		}
        
    	CharSequence [] entries = {"No Sound","Big Ben"};
    	CharSequence [] entryValues = {"","android.resource://goo.TeaTimer/" + R.raw.big_ben};
    	
    	//Default value
    	if(tone.getValue() == null) tone.setValue((String)entryValues[1]);
    	
    	if( items != null && items.length > 0){
            CharSequence[] tmp = new CharSequence[entries.length+items.length];
    	    System.arraycopy(entries, 0, tmp, 0, entries.length);
    	    System.arraycopy(items, 0, tmp, entries.length, items.length);
    		tone.setEntries(tmp);
            
            tmp = new CharSequence[entryValues.length+itemUris.length];
    	    System.arraycopy(entryValues, 0, tmp, 0, entryValues.length);
    	    System.arraycopy(itemUris, 0, tmp, entryValues.length, itemUris.length);
    		tone.setEntryValues(tmp);
    	}else{
    		tone.setEntries(entries);
    		tone.setEntryValues(entryValues);
    	}
    	
    }
}
